var TEMP_TEXTURE = false;

var imgs = {};
var texs = {};

function Texture(src, isOnDoc) {
    if(!TEMP_TEXTURE) {
        TEMP_TEXTURE = gl.createTexture();
        gl.bindTexture(gl.TEXTURE_2D, TEMP_TEXTURE);
        gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, 1, 1, 0, gl.RGBA, gl.UNSIGNED_BYTE, new Uint8Array([255, 0, 0, 255])); // red
    }
    
    this.id = TEMP_TEXTURE
    
    if(isOnDoc) {
        var img = document.getElementById(src);
        texs[img.src] = this;
        texs[img.src].id = gl.createTexture();
        gl.bindTexture(gl.TEXTURE_2D, texs[img.src].id);
        gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, img);
        texs[img.src].Setup(img.width, img.height);
    } else {
        var img = new Image();
        img.crossOrigin = '';
        img.src = src;
        texs[img.src] = this;
        img.onload = function() {
            texs[img.src].id = gl.createTexture();
            gl.bindTexture(gl.TEXTURE_2D, texs[img.src].id);
            gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, img);
            texs[img.src].Setup(img.width, img.height);
        }
    }
}

Texture.prototype.Setup = function(width, height) {
    if (IsPowerOf2(width) && IsPowerOf2(height)) {
        gl.generateMipmap(gl.TEXTURE_2D);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
    } else {
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
        gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
    }
    
    gl.bindTexture(gl.TEXTURE_2D, null);
}

function TextureCallbackLoad(texture, data) {
    texture.Load(data);
}

Texture.prototype.Load = function(data) {
    gl.bindTexture(gl.TEXTURE_2D, this.id);
    gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, gl.UNSIGNED_BYTE, data);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
    gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
    gl.bindTexture(gl.TEXTURE_2D, null);
}

Texture.prototype.Bind = function() {
       gl.bindTexture(gl.TEXTURE_2D, this.id);
}

Texture.prototype.Unbind = function() {
   gl.bindTexture(gl.TEXTURE_2D, null);
}
