window.addEventListener('load', EngineMain(document.getElementById("canvas"), Load, Update, Draw), false);

var TOP_SCORE = GetCookie("TopScore");

var frames, fps, timer;
var text, scoreText, currentScoreText;

var score = 0;

var shakeX = 0, shakeY = 0;
var hasStarted = false;
var hasDied = false;

var lScoreSound = new Sound("https://dl.dropbox.com/s/js8mb7bb05vzqmo/25score.ogg?dl=0");
var hScoreSound = new Sound("https://dl.dropbox.com/s/mzwsneyuof3mrl9/50score.ogg?dl=0");
var playerSound = new Sound("https://dl.dropbox.com/s/wjj8mrm3zfa9ndj/explosion.wav?dl=0");
var music = new Sound("https://dl.dropbox.com/s/7r3pemmaqkne0xy/music.ogg?dl=0");
music.audio.addEventListener('canplay', function() {
        if(!isPlaying) {
        music.SetVolume(0.25);
        music.Loop();
        isPlaying = true;
        playerSound.SetVolume(0.5);
        lScoreSound.SetVolume(0.5);
        lScoreSound.Stop();
    }
});
var isPlaying = false;

var playerParticles = [];

var muteMusicTex = new Sprite(new Texture("https://dl.dropbox.com/s/9ppqyph01avxkpm/MusicTex.png?dl=0"));
var unmuteMusicTex = new Sprite(new Texture("https://dl.dropbox.com/s/wr3f3tp7nsx78lb/MusicTexMuted.png?dl=0"));
var isMusicMuted = false;
var musicRectangle = {
    left: 800-32,
    right: 800,
    top: 600-10-64,
    bottom: 600-10-32
};

var muteSoundTex = new Sprite(new Texture("https://dl.dropbox.com/s/vue8bg7zxq33los/SoundTex.png?dl=0"));
var unmuteSoundTex = new Sprite(new Texture("https://dl.dropbox.com/s/bi73y1fsxmbvtlc/SoundTexMuted.png?dl=0"));
var isSoundMuted = false;
var soundRectangle = {
    left: 800-32,
    right: 800,
    top: 600-5-32,
    bottom: 600-5
};

var multiplier = 1;

var gateSprite = new Sprite(null, [0.8, 0.8, 0.8, 1.0]);

var gates = [];

var cameraPos = {
  x: 300,
  y: 400
};

var player = {
    x: 400,
    y: 300,
    size: 32,
    velx: 0,
    vely: 0,
    friction: 0.85,
    motionBlur: []
};

var ADOWN = false;
var DDOWN = false;

var playerBlurSprites = [
    new Sprite(new Texture("https://dl.dropbox.com/s/qqvjv3wwgscu0j7/player.png?dl=0")),
];

var enemyTimer = 0;

function Load() {
    gl.clearColor(1, 1, 0, 1);
    SIMPLE_SHADER = new Shader(BASIC_SHADER_VS, BASIC_SHADER_FS);

    text = new Text("temp", 22);
    currentScoreText = new Text("temp", 22);
    scoreText = new Text("Score:", 36);
    comboText = new Text("null", 36);

    fps = 0;
    frames = 0;
    timer = Date.now();
}

function Update(dt) {
    cameraPos.x = player.x;
    cameraPos.y = player.y;

    var mouseRect = {
        left: mouse.x,
        right: mouse.x + 1,
        top: mouse.y,
        bottom: mouse.y + 1
    };

    if(gates.length < 1 || gates[gates.length - 1].top.x < player.x + (-score / 5)) {
      var gap = Math.random() * 300 + 150;
      var gapPos = Math.random() * 400 + 100;
      gates.push({
        top: {
          x: player.x + 700,
          y: (gapPos - gap / 2) / 2,
          width: 16,
          height: (gapPos - gap / 2),
        },
        bottom: {
          x: player.x + 700,
          y: (600 + (gapPos + gap / 2)) / 2,
          width: 16,
          height: 600 - (gapPos - gap / 2),
        },
        pointzones: [
          {
            x: player.x + 700,
            y: gapPos - gap / 2 + gap / 10 - 6,
            width: 16,
            height: gap / 5.5,
            sprite: new Sprite(null, [0.0, 0.7, 0.0, 0.4]),
            score: 25,
          },
          {
            x: player.x + 700,
            y: gapPos - gap / 4,
            width: 16,
            height: gap / 5.5,
            sprite: new Sprite(null, [0.0, 0.0, 0.7, 0.4]),
            score: 50,
          },
          {
            x: player.x + 700,
            y: gapPos - gap / 20 - 6,
            width: 16,
            height: gap / 5.5,
            sprite: new Sprite(null, [0.0, 0.7, 0.0, 0.4]),
            score: 25
          },
        ],
      });
    }

    if(Date.now() - timer >= 1000) {
        fps = frames;
        frames = 0;
        timer = Date.now();
        text.SetText(fps + " fps");
    }

    if(player.velx < -15) player.velx = -15;
    if(player.velx >  15) player.velx =  15;
    if(player.vely < -15) player.vely = -15;
    if(player.vely >  15) player.vely =  15;

    player.velx *= player.friction;
    player.vely *= player.friction;
    player.x += player.velx;
    player.y += player.vely;

    if(hasStarted) {
        player.size += 0.2 + Math.log(Math.pow(score + 1, 0.01));
        if(player.size < 14) player.size = 14;
    }

    if(hasStarted && Keyboard.IsDown(Keys.W)) {
      player.vely -= 2;
      if(!ADOWN) {
        player.size -= 3;
        player.velx += 6.5;
        ADOWN = true;
      }
    } else {
      ADOWN = false;
    }

    if(hasStarted && Keyboard.IsDown(Keys.S)) {
      player.vely += 2;
      if(!DDOWN) {
        player.size -= 3;
        player.velx += 6.5;
        DDOWN = true;
      }
    } else {
      DDOWN = false;
    }

    if(!hasStarted && playerParticles.length < 20 && (Keyboard.IsDown(Keys.S) || Keyboard.IsDown(Keys.W))) {
      score = 0;
      multiplier = 1;
      gates = [];
      player.x = 150;
      player.y = 300;
      player.size = 24;
      hasStarted = true;
    }

    playerParticles.push({
                x: player.x,
                y: player.y,
                life: 5 + Math.random() * 25,
                velx: (Math.random() - 0.5) * 3,
                vely: (Math.random() - 0.5) * 3,
                size: Math.random() * 12
    });

    if(player.y < player.size/2) player.y = player.size/2;
    if(player.y > 600-player.size/2) player.y = 600-player.size/2;

    if(hasStarted) {
        for(var i = 0; i < gates.length; i++) {
          if(gates[i].top.x < player.x - 200) gates.splice(i, 1);


          if(RectangleCollision({ left: player.x - player.size / 2, top: player.y - player.size / 2,
                                  right: player.x + player.size / 2, bottom: player.y + player.size / 2},
                                { left: gates[i].top.x - gates[i].top.width / 2, top: gates[i].top.y - gates[i].top.height / 2,
                                  right: gates[i].top.x + gates[i].top.width / 2, bottom: gates[i].top.y + gates[i].top.height / 2})) {
            hasStarted = false;
            var numParts = Math.ceil(Math.random() * 30) + 100;
            console.log(numParts);
            for(var j = 0; j < numParts; j++) {
                playerParticles.push({
                    x: player.x,
                    y: player.y,
                    life: 10 + Math.random() * 60,
                    velx: (Math.random() - 0.5) * 20,
                    vely: (Math.random() - 0.5) * 20,
                    size: Math.random() * 10
                });
            }
            player.size = 24;
            playerSound.Play();
            if(score > TOP_SCORE) {
              TOP_SCORE = score;
            }
          }


          if(RectangleCollision({ left: player.x - player.size / 2, top: player.y - player.size / 2,
                                  right: player.x + player.size / 2, bottom: player.y + player.size / 2},
                                { left: gates[i].bottom.x - gates[i].bottom.width / 2, top: gates[i].bottom.y - gates[i].bottom.height / 2,
                                  right: gates[i].bottom.x + gates[i].bottom.width / 2, bottom: gates[i].bottom.y + gates[i].bottom.height / 2})) {
            hasStarted = false;
            var numParts = Math.ceil(Math.random() * 100) + 10;
            for(var j = 0; j < numParts; j++) {
                playerParticles.push({
                    x: player.x,
                    y: player.y,
                    life: 10 + Math.random() * 60,
                    velx: (Math.random() - 0.5) * 20,
                    vely: (Math.random() - 0.5) * 20,
                    size: Math.random() * 10
                });
            }
            player.size = 24;
            playerSound.Play();
            if(score > TOP_SCORE) {
              TOP_SCORE = score;
            }
          }

      var curScore = 0;
      for(var j = 0; j < gates[i].pointzones.length; j++) {
        var zone = gates[i].pointzones[j];
        if(RectangleCollision({ left: player.x - player.size / 2, top: player.y - player.size / 2,
                                right: player.x + player.size / 2, bottom: player.y + player.size / 2},
                              { left: zone.x - zone.width / 2, top: zone.y - zone.height / 2,
                                right: zone.x + zone.width / 2, bottom: zone.y + zone.height / 2})) {
          curScore = zone.score;
        }
      }

      if(curScore >= 50) {
        multiplier += 0.1;
        hScoreSound.Play();
      } else if (curScore > 0 ){
        lScoreSound.Play();
        multiplier = 1;
      }

      if(curScore > 0) {
        score += curScore * multiplier;
        shakeX += curScore * multiplier;
        shakeY += curScore * multiplier;
        gates[i].pointzones = [];
        var numParts = Math.ceil(Math.random() * 40) + 10;
        for(var j = 0; j < numParts; j++) {
            playerParticles.push({
                x: player.x,
                y: player.y,
                life: 10 + Math.random() * 60,
                velx: (Math.random() - 0.5) * 20,
                vely: (Math.random() - 0.5) * 20,
                size: Math.random() * 10
            });
        }
      }
    }
  }

    for(var i = 0; i < player.motionBlur.length; i++) {
      player.motionBlur[i].age++;
    }

    player.motionBlur.push({
        age: 0,
        x: player.x,
        y: player.y,
        size: player.size
    });

    if(player.motionBlur.length > 13) {
        player.motionBlur = player.motionBlur.splice(1, 12);
    }

    for(var i = 0; i < playerParticles.length; i++) {
        playerParticles[i].life--;
        if(playerParticles[i].life < 0) {
            playerParticles.splice(i, 1);
            continue;
        }

        playerParticles[i].x += playerParticles[i].velx;
        playerParticles[i].y += playerParticles[i].vely;
    }

    if(!hasStarted && playerParticles.length == 0) {
        if(score > TOP_SCORE) {
            TOP_SCORE = score;
            SetCookie("TopScore", TOP_SCORE.toFixed(0), 10000);
        }
    }

    shakeX *= 0.9;
    shakeY *= 0.9;

    if(mouseClick && RectangleCollision(mouseRect, musicRectangle)) {
        isMusicMuted = !isMusicMuted;
        if(isMusicMuted) {
            music.Stop();
        } else {
            music.Loop();
        }
    }

    if(mouseClick && RectangleCollision(mouseRect, soundRectangle)) {
        isSoundMuted = !isSoundMuted;
        if(isSoundMuted) {
            playerSound.SetVolume(0);
        } else {
            playerSound.SetVolume(0.5);
        }
    }

    mouseClick = 0;
}

function Draw(dt) {
    var sx = (Math.random() - 0.5) * shakeX - cameraPos.x + 150;
    var sy = (Math.random() - 0.5) * shakeY;

    SpriteSetShader(SIMPLE_SHADER);

    if(!hasDied) {
        playerBlurSprites[0].Draw(player.x + sx, player.y + sy, player.size, player.size, 0);
    }

    for(var i = 1; i < player.motionBlur.length; i++) {
        var dx = (player.motionBlur[i].x + player.motionBlur[i-1].x) / 2 + sx;
        var dy = (player.motionBlur[i].y + player.motionBlur[i-1].y) / 2 + sy;

        playerBlurSprites[0].Draw(dx, dy, player.motionBlur[i].size, player.motionBlur[i].size);
        playerBlurSprites[0].Draw(player.motionBlur[i].x + sx, player.motionBlur[i].y + sy, player.motionBlur[i].size, player.motionBlur[i].size);
    }
    for(var i = 0; i < playerParticles.length; i++) {
        playerBlurSprites[0].Draw(playerParticles[i].x + sx, playerParticles[i].y + sy, playerParticles[i].size, playerParticles[i].size);
    }

    for(var i = 0; i < gates.length; i++) {
      gateSprite.Draw(gates[i].top.x + sx, gates[i].top.y + sy, gates[i].top.width, gates[i].top.height);
      gateSprite.Draw(gates[i].bottom.x + sx, gates[i].bottom.y + sy, gates[i].bottom.width, gates[i].bottom.height);

      for(var j = 0; j < gates[i].pointzones.length; j++) {
        var zone = gates[i].pointzones[j];
        zone.sprite.Draw(zone.x + sx, zone.y + sy, zone.width, zone.height);
      }
    }

    if(!hasStarted) {
        text.SetText("Worm wiggly hoop-loop!");
        text.Draw(260, 80);
        text.SetText("Use W and S to give yourself a jolt of speed.");
        text.Draw(115, 440);
        text.SetText("Alternate the keys to move forward.");
        text.Draw(115, 470);
        text.SetText("Not moving forward will make you grow bigger.");
        text.Draw(115, 500);
        text.SetText("More score makes you grow faster.");
        text.Draw(115, 530);
        text.SetText("Move to start.");
        text.Draw(250, 560);
        text.SetText(fps + " fps");

        if(TOP_SCORE != 0) {
            scoreText.SetText("Highscore: " + TOP_SCORE.toFixed(0));
            scoreText.Draw(270, 30);
        }
    } else {
      currentScoreText.SetText("Score: " + score.toFixed(0));
      currentScoreText.Draw(330, 5);

      currentScoreText.SetText("Multiplier: " + multiplier.toFixed(1) + "x");
      currentScoreText.Draw(5, 30);
    }

    if(!isMusicMuted) {
        muteMusicTex.Draw(musicRectangle.left + 16, musicRectangle.top + 16, 32, 32);
    } else {
        unmuteMusicTex.Draw(musicRectangle.left + 16, musicRectangle.top + 16, 32, 32);
    }

    if(!isSoundMuted) {
        muteSoundTex.Draw(soundRectangle.left + 16, soundRectangle.top + 16, 32, 32);
    } else {
        unmuteSoundTex.Draw(soundRectangle.left + 16, soundRectangle.top + 16, 32, 32);
    }

    text.Draw(5, 5);
    frames++;
}

function RectangleCollision(r1, r2) {
  return !(r2.left > r1.right ||
           r2.right < r1.left ||
           r2.top > r1.bottom ||
           r2.bottom < r1.top);
}

function DistanceTo(x1, y1, x2, y2) {
    return Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
}

function Normalize(x, y) {
    var length = Math.sqrt(x * x + y * y);
    return [x / length, y / length];
}

function Sign(x) { return x ? x < 0 ? -1 : 1 : 0; }

function GetCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for(var i=0; i<ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0)==' ') c = c.substring(1);
        if (c.indexOf(name) == 0) return (c.substring(name.length,c.length));
    }
    return 0;
}

function SetCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays*24*60*60*1000));
    var expires = "expires="+d.toUTCString();
    document.cookie = cname + "=" + cvalue + "; " + expires + "; path=/";
}
